// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_polaris_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice
#include "dbw_polaris_msgs/msg/detail/steering_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
dbw_polaris_msgs__msg__SteeringCmd__init(dbw_polaris_msgs__msg__SteeringCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_polaris_msgs__msg__SteeringCmd__fini(msg);
    return false;
  }
  // steering_wheel_angle_cmd
  // steering_wheel_angle_velocity
  // steering_wheel_torque_cmd
  // cmd_type
  // enable
  // clear
  // ignore
  // calibrate
  // quiet
  // alert
  // count
  return true;
}

void
dbw_polaris_msgs__msg__SteeringCmd__fini(dbw_polaris_msgs__msg__SteeringCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // steering_wheel_angle_cmd
  // steering_wheel_angle_velocity
  // steering_wheel_torque_cmd
  // cmd_type
  // enable
  // clear
  // ignore
  // calibrate
  // quiet
  // alert
  // count
}

dbw_polaris_msgs__msg__SteeringCmd *
dbw_polaris_msgs__msg__SteeringCmd__create()
{
  dbw_polaris_msgs__msg__SteeringCmd * msg = (dbw_polaris_msgs__msg__SteeringCmd *)malloc(sizeof(dbw_polaris_msgs__msg__SteeringCmd));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_polaris_msgs__msg__SteeringCmd));
  bool success = dbw_polaris_msgs__msg__SteeringCmd__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_polaris_msgs__msg__SteeringCmd__destroy(dbw_polaris_msgs__msg__SteeringCmd * msg)
{
  if (msg) {
    dbw_polaris_msgs__msg__SteeringCmd__fini(msg);
  }
  free(msg);
}


bool
dbw_polaris_msgs__msg__SteeringCmd__Sequence__init(dbw_polaris_msgs__msg__SteeringCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_polaris_msgs__msg__SteeringCmd * data = NULL;
  if (size) {
    data = (dbw_polaris_msgs__msg__SteeringCmd *)calloc(size, sizeof(dbw_polaris_msgs__msg__SteeringCmd));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_polaris_msgs__msg__SteeringCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_polaris_msgs__msg__SteeringCmd__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_polaris_msgs__msg__SteeringCmd__Sequence__fini(dbw_polaris_msgs__msg__SteeringCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_polaris_msgs__msg__SteeringCmd__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_polaris_msgs__msg__SteeringCmd__Sequence *
dbw_polaris_msgs__msg__SteeringCmd__Sequence__create(size_t size)
{
  dbw_polaris_msgs__msg__SteeringCmd__Sequence * array = (dbw_polaris_msgs__msg__SteeringCmd__Sequence *)malloc(sizeof(dbw_polaris_msgs__msg__SteeringCmd__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_polaris_msgs__msg__SteeringCmd__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_polaris_msgs__msg__SteeringCmd__Sequence__destroy(dbw_polaris_msgs__msg__SteeringCmd__Sequence * array)
{
  if (array) {
    dbw_polaris_msgs__msg__SteeringCmd__Sequence__fini(array);
  }
  free(array);
}
