// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from dbw_polaris_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice

#ifndef DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
#define DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'CMD_ANGLE'.
enum
{
  dbw_polaris_msgs__msg__SteeringCmd__CMD_ANGLE = 0
};

/// Constant 'CMD_TORQUE'.
enum
{
  dbw_polaris_msgs__msg__SteeringCmd__CMD_TORQUE = 1
};

/// Constant 'ANGLE_MAX'.
static const float dbw_polaris_msgs__msg__SteeringCmd__ANGLE_MAX = 10.5f;

/// Constant 'VELOCITY_MAX'.
static const float dbw_polaris_msgs__msg__SteeringCmd__VELOCITY_MAX = 17.5f;

/// Constant 'TORQUE_MAX'.
static const float dbw_polaris_msgs__msg__SteeringCmd__TORQUE_MAX = 60.0f;

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

// Struct defined in msg/SteeringCmd in the package dbw_polaris_msgs.
typedef struct dbw_polaris_msgs__msg__SteeringCmd
{
  std_msgs__msg__Header header;
  float steering_wheel_angle_cmd;
  float steering_wheel_angle_velocity;
  float steering_wheel_torque_cmd;
  uint8_t cmd_type;
  bool enable;
  bool clear;
  bool ignore;
  bool calibrate;
  bool quiet;
  bool alert;
  uint8_t count;
} dbw_polaris_msgs__msg__SteeringCmd;

// Struct for a sequence of dbw_polaris_msgs__msg__SteeringCmd.
typedef struct dbw_polaris_msgs__msg__SteeringCmd__Sequence
{
  dbw_polaris_msgs__msg__SteeringCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} dbw_polaris_msgs__msg__SteeringCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_H_
