// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from dbw_polaris_msgs:msg/SteeringReport.idl
// generated code does not contain a copyright notice

#ifndef DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_REPORT__FUNCTIONS_H_
#define DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_REPORT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "dbw_polaris_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "dbw_polaris_msgs/msg/detail/steering_report__struct.h"

/// Initialize msg/SteeringReport message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * dbw_polaris_msgs__msg__SteeringReport
 * )) before or use
 * dbw_polaris_msgs__msg__SteeringReport__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
bool
dbw_polaris_msgs__msg__SteeringReport__init(dbw_polaris_msgs__msg__SteeringReport * msg);

/// Finalize msg/SteeringReport message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
void
dbw_polaris_msgs__msg__SteeringReport__fini(dbw_polaris_msgs__msg__SteeringReport * msg);

/// Create msg/SteeringReport message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * dbw_polaris_msgs__msg__SteeringReport__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
dbw_polaris_msgs__msg__SteeringReport *
dbw_polaris_msgs__msg__SteeringReport__create();

/// Destroy msg/SteeringReport message.
/**
 * It calls
 * dbw_polaris_msgs__msg__SteeringReport__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
void
dbw_polaris_msgs__msg__SteeringReport__destroy(dbw_polaris_msgs__msg__SteeringReport * msg);


/// Initialize array of msg/SteeringReport messages.
/**
 * It allocates the memory for the number of elements and calls
 * dbw_polaris_msgs__msg__SteeringReport__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
bool
dbw_polaris_msgs__msg__SteeringReport__Sequence__init(dbw_polaris_msgs__msg__SteeringReport__Sequence * array, size_t size);

/// Finalize array of msg/SteeringReport messages.
/**
 * It calls
 * dbw_polaris_msgs__msg__SteeringReport__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
void
dbw_polaris_msgs__msg__SteeringReport__Sequence__fini(dbw_polaris_msgs__msg__SteeringReport__Sequence * array);

/// Create array of msg/SteeringReport messages.
/**
 * It allocates the memory for the array and calls
 * dbw_polaris_msgs__msg__SteeringReport__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
dbw_polaris_msgs__msg__SteeringReport__Sequence *
dbw_polaris_msgs__msg__SteeringReport__Sequence__create(size_t size);

/// Destroy array of msg/SteeringReport messages.
/**
 * It calls
 * dbw_polaris_msgs__msg__SteeringReport__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_polaris_msgs
void
dbw_polaris_msgs__msg__SteeringReport__Sequence__destroy(dbw_polaris_msgs__msg__SteeringReport__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // DBW_POLARIS_MSGS__MSG__DETAIL__STEERING_REPORT__FUNCTIONS_H_
